part of '../../../account_management.dart';

class AccountFilter extends NameFilter<int, AccountModel> {
  final InWhere<int>? branchIds;
  final InWhere<int>? typeIds;
  final InWhere<int>? levelIds;
  final InWhere<int>? groupIds;
  final InWhere<int>? upIds;

  final InWhere<int>? userIds;
  const AccountFilter({
    super.ids,
    super.status,
    super.text,
    this.branchIds,
    this.typeIds,
    this.levelIds,
    this.groupIds,
    this.upIds,
    this.userIds,
  });

  @override
  Map<String, dynamic> toMap() => {
        "branchIds": branchIds?.toMap(),
        "typeIds": typeIds?.toMap(),
        "levelIds": levelIds?.toMap(),
        "groupIds": groupIds?.toMap(),
        "upIds": upIds?.toMap(),
        "userIds": userIds?.toMap(),
      };

  @override
  bool check(AccountModel element) =>
      super.check(element) &&
      (branchIds?.check(element.branchId) ?? true) &&
      (typeIds?.check(element.typeId) ?? true) &&
      (levelIds?.check(element.levelId) ?? true) &&
      (groupIds?.check(element.groupId) ?? true) &&
      (upIds?.check(element.upId) ?? true) &&
      (userIds?.check(element.userId) ?? true);
}
