part of '../../../account_management.dart';

class AccountCurrencyFilter extends TableFilter<AccountCurrencyModel> {
  final InWhere<int>? branchIds;
  final InWhere<int>? accountIds;
  final InWhere<int>? currencyIds;
  final NumberRangeWhere<double>? price;
  final DateTimeRangeWhere? createAt;
  final InWhere<int>? userIds;

  const AccountCurrencyFilter({
    this.branchIds,
    this.accountIds,
    this.currencyIds,
    this.price,
    this.createAt,
    this.userIds,
  });

  @override
  Map<String, dynamic> toMap() => {
        "branchIds": branchIds?.toMap(),
        "accountIds": accountIds?.toMap(),
        "currencyIds": currencyIds?.toMap(),
        "price": price?.toMap(),
        "createAt": createAt?.toMap(),
        "userIds": userIds?.toMap(),
      };

  @override
  bool check(AccountCurrencyModel element) =>
      super.check(element) &&
      (branchIds?.check(element.branchId) ?? true) &&
      (accountIds?.check(element.accountId) ?? true) &&
      (currencyIds?.check(element.currencyId) ?? true) &&
      (price?.check(element.price) ?? true) &&
      (createAt?.check(element.createAt) ?? true) &&
      (userIds?.check(element.userId) ?? true);
}
