part of '../../../account_management.dart';

class ReceiptDetailFilter extends TableFilter<ReceiptDetailModel> {
  final InWhere<int>? branchIds;
  final InWhere<int>? typeIds;
  final InWhere<int>? receiptIds;
  final InWhere<int>? accountIds;
  final InWhere<int>? currencyIds;
  final NumberRangeWhere<double>? price;
  final LikeWhere? text;
  const ReceiptDetailFilter({
    this.branchIds,
    this.typeIds,
    this.receiptIds,
    this.accountIds,
    this.currencyIds,
    this.price,
    this.text,
  });

  @override
  Map<String, dynamic> toMap() => {
        "branchIds": branchIds?.toMap(),
        "typeIds": typeIds?.toMap(),
        "receiptIds": receiptIds?.toMap(),
        "accountIds": accountIds?.toMap(),
        "currencyIds": currencyIds?.toMap(),
        "price": price?.toMap(),
        "text": text?.toMap(),
      };

  @override
  bool check(ReceiptDetailModel element) =>
      super.check(element) &&
      (branchIds?.check(element.branchId) ?? true) &&
      (typeIds?.check(element.typeId) ?? true) &&
      (receiptIds?.check(element.receiptId) ?? true) &&
      (accountIds?.check(element.accountId) ?? true) &&
      (currencyIds?.check(element.currencyId) ?? true) &&
      (price?.check(element.price) ?? true) &&
      (text?.check(element.description) ?? true);
}
