part of '../../../permission_management.dart';

class BranchUserPermissionFilter
    extends TableFilter<BranchUserPermissionModel> {
  final InWhere<int>? branchIds;
  final InWhere<int>? permissionIds;
  final InWhere<int>? userIds;
  final InWhere<bool>? status;
  final InWhere<bool>? permissionStatus;

  const BranchUserPermissionFilter({
    this.branchIds,
    this.permissionIds,
    this.userIds,
    this.status,
    this.permissionStatus,
  });

  @override
  Map<String, dynamic> toMap() => {
        "branchIds": branchIds?.toMap(),
        "permissionIds": permissionIds?.toMap(),
        "userIds": userIds?.toMap(),
        "status": status?.toMap(),
        "permissionStatus": permissionStatus?.toMap(),
      };

  @override
  bool check(BranchUserPermissionModel element) =>
      super.check(element) &&
      (branchIds?.check(element.branchId) ?? true) &&
      (permissionIds?.check(element.permissionId) ?? true) &&
      (userIds?.check(element.userId) ?? true) &&
      (status?.check(element.status) ?? true) &&
      (permissionStatus?.check(element.permissionStatus) ?? true) &&
      (userIds?.check(element.userId) ?? true);
}
