part of '../../../permission_management.dart';

class PermissionFilter extends NameFilter<int, PermissionModel> {
  final InWhere<int>? upIds;
  final InWhere<int>? typeIds;
  const PermissionFilter({
    super.ids,
    super.status,
    super.text,
    this.typeIds,
    this.upIds,
  });

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        "upIds": upIds?.toMap(),
        "typeIds": typeIds?.toMap(),
      };

  @override
  bool check(PermissionModel element) =>
      super.check(element) &&
      (upIds?.check(element.upId) ?? true) &&
      (typeIds?.check(element.typeId) ?? true);
}
